unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ppClass, ppBands, ppCache, ppComm, ppRelatv, ppProd, ppReport,
  StdCtrls, ppPrnabl, ppCtrls, ppDB, DB, DBTables, ppDBPipe;

type
  TForm1 = class(TForm)
    ppReport1: TppReport;
    ppHeaderBand1: TppHeaderBand;
    ppDetailBand1: TppDetailBand;
    ppFooterBand1: TppFooterBand;
    btnPreview: TButton;
    ppShape1: TppShape;
    plCustomer: TppDBPipeline;
    tblCustomer: TTable;
    dsCustomer: TDataSource;
    ppDBText1: TppDBText;
    procedure ppDetailBand1BeforePrint(Sender: TObject);
    procedure btnPreviewClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  ppTypes, ppUtils;

{$R *.dfm}

procedure TForm1.btnPreviewClick(Sender: TObject);
begin
  ppReport1.Print;
end;

procedure TForm1.ppDetailBand1BeforePrint(Sender: TObject);
var
  liSpaceAvailable: Integer;
begin

  {calc page space available - units here are microns (i.e. mm thousandths)}
  liSpaceAvailable := ppReport1.Engine.PageBottom - ppReport1.Engine.PrintPosRect.Top;

  {convert microns to Report.Units - using inches here}
  liSpaceAvailable := Trunc(ppFromMMThousandths(liSpaceAvailable, ppReport1.Units, pprtVertical, ppReport1.Printer));

  {force new page when less than 5 inches of page space remaining}
  if (liSpaceAvailable < 5) then
    begin
     ppReport1.Detail.OutOfSpace := True;
     ShowMessage('Space Available < 5, forcing new page..');
    end
  else
    ShowMessage('Space Available: ' + IntToStr(liSpaceAvailable));

end;



end.
